/*
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jdbi.v3.core.argument.internal;

import org.jdbi.v3.core.qualifier.QualifiedType;

public class TypedValue {
    final QualifiedType<?> type;
    final Object value;

    public TypedValue(QualifiedType<?> qualifiedType, Object value) {
        this.type = qualifiedType;
        this.value = value;
    }

    public QualifiedType<?> getType() {
        return type;
    }

    public Object getValue() {
        return value;
    }

    @Override
    public String toString() {
        return "(" + type + ") " + value;
    }
}
